require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_LINUX_EXT4_H)) {
    eval 'sub _LINUX_EXT4_H () {1;}' unless defined(&_LINUX_EXT4_H);
    require 'linux/fiemap.ph';
    require 'linux/fs.ph';
    require 'linux/ioctl.ph';
    require 'linux/types.ph';
    eval 'sub EXT4_IOC_GETVERSION () { &_IOR(ord(\'f\'), 3, \'long\');}' unless defined(&EXT4_IOC_GETVERSION);
    eval 'sub EXT4_IOC_SETVERSION () { &_IOW(ord(\'f\'), 4, \'long\');}' unless defined(&EXT4_IOC_SETVERSION);
    eval 'sub EXT4_IOC_GETVERSION_OLD () { &FS_IOC_GETVERSION;}' unless defined(&EXT4_IOC_GETVERSION_OLD);
    eval 'sub EXT4_IOC_SETVERSION_OLD () { &FS_IOC_SETVERSION;}' unless defined(&EXT4_IOC_SETVERSION_OLD);
    eval 'sub EXT4_IOC_GETRSVSZ () { &_IOR(ord(\'f\'), 5, \'long\');}' unless defined(&EXT4_IOC_GETRSVSZ);
    eval 'sub EXT4_IOC_SETRSVSZ () { &_IOW(ord(\'f\'), 6, \'long\');}' unless defined(&EXT4_IOC_SETRSVSZ);
    eval 'sub EXT4_IOC_GROUP_EXTEND () { &_IOW(ord(\'f\'), 7, \'unsigned long\');}' unless defined(&EXT4_IOC_GROUP_EXTEND);
    eval 'sub EXT4_IOC_GROUP_ADD () { &_IOW(ord(\'f\'), 8, \'struct ext4_new_group_input\');}' unless defined(&EXT4_IOC_GROUP_ADD);
    eval 'sub EXT4_IOC_MIGRATE () { &_IO(ord(\'f\'), 9);}' unless defined(&EXT4_IOC_MIGRATE);
    eval 'sub EXT4_IOC_ALLOC_DA_BLKS () { &_IO(ord(\'f\'), 12);}' unless defined(&EXT4_IOC_ALLOC_DA_BLKS);
    eval 'sub EXT4_IOC_MOVE_EXT () { &_IOWR(ord(\'f\'), 15, \'struct move_extent\');}' unless defined(&EXT4_IOC_MOVE_EXT);
    eval 'sub EXT4_IOC_RESIZE_FS () { &_IOW(ord(\'f\'), 16,  &__u64);}' unless defined(&EXT4_IOC_RESIZE_FS);
    eval 'sub EXT4_IOC_SWAP_BOOT () { &_IO(ord(\'f\'), 17);}' unless defined(&EXT4_IOC_SWAP_BOOT);
    eval 'sub EXT4_IOC_PRECACHE_EXTENTS () { &_IO(ord(\'f\'), 18);}' unless defined(&EXT4_IOC_PRECACHE_EXTENTS);
    eval 'sub EXT4_IOC_CLEAR_ES_CACHE () { &_IO(ord(\'f\'), 40);}' unless defined(&EXT4_IOC_CLEAR_ES_CACHE);
    eval 'sub EXT4_IOC_GETSTATE () { &_IOW(ord(\'f\'), 41,  &__u32);}' unless defined(&EXT4_IOC_GETSTATE);
    eval 'sub EXT4_IOC_GET_ES_CACHE () { &_IOWR(ord(\'f\'), 42, \'struct fiemap\');}' unless defined(&EXT4_IOC_GET_ES_CACHE);
    eval 'sub EXT4_IOC_CHECKPOINT () { &_IOW(ord(\'f\'), 43,  &__u32);}' unless defined(&EXT4_IOC_CHECKPOINT);
    eval 'sub EXT4_IOC_GETFSUUID () { &_IOR(ord(\'f\'), 44, \'struct fsuuid\');}' unless defined(&EXT4_IOC_GETFSUUID);
    eval 'sub EXT4_IOC_SETFSUUID () { &_IOW(ord(\'f\'), 44, \'struct fsuuid\');}' unless defined(&EXT4_IOC_SETFSUUID);
    eval 'sub EXT4_IOC_SHUTDOWN () { &_IOR(ord(\'X\'), 125,  &__u32);}' unless defined(&EXT4_IOC_SHUTDOWN);
    eval 'sub EXT4_IOC32_GETVERSION () { &_IOR(ord(\'f\'), 3, \'int\');}' unless defined(&EXT4_IOC32_GETVERSION);
    eval 'sub EXT4_IOC32_SETVERSION () { &_IOW(ord(\'f\'), 4, \'int\');}' unless defined(&EXT4_IOC32_SETVERSION);
    eval 'sub EXT4_IOC32_GETRSVSZ () { &_IOR(ord(\'f\'), 5, \'int\');}' unless defined(&EXT4_IOC32_GETRSVSZ);
    eval 'sub EXT4_IOC32_SETRSVSZ () { &_IOW(ord(\'f\'), 6, \'int\');}' unless defined(&EXT4_IOC32_SETRSVSZ);
    eval 'sub EXT4_IOC32_GROUP_EXTEND () { &_IOW(ord(\'f\'), 7, \'unsigned int\');}' unless defined(&EXT4_IOC32_GROUP_EXTEND);
    eval 'sub EXT4_IOC32_GROUP_ADD () { &_IOW(ord(\'f\'), 8, \'struct compat_ext4_new_group_input\');}' unless defined(&EXT4_IOC32_GROUP_ADD);
    eval 'sub EXT4_IOC32_GETVERSION_OLD () { &FS_IOC32_GETVERSION;}' unless defined(&EXT4_IOC32_GETVERSION_OLD);
    eval 'sub EXT4_IOC32_SETVERSION_OLD () { &FS_IOC32_SETVERSION;}' unless defined(&EXT4_IOC32_SETVERSION_OLD);
    eval 'sub EXT4_STATE_FLAG_EXT_PRECACHED () {0x1;}' unless defined(&EXT4_STATE_FLAG_EXT_PRECACHED);
    eval 'sub EXT4_STATE_FLAG_NEW () {0x2;}' unless defined(&EXT4_STATE_FLAG_NEW);
    eval 'sub EXT4_STATE_FLAG_NEWENTRY () {0x4;}' unless defined(&EXT4_STATE_FLAG_NEWENTRY);
    eval 'sub EXT4_STATE_FLAG_DA_ALLOC_CLOSE () {0x8;}' unless defined(&EXT4_STATE_FLAG_DA_ALLOC_CLOSE);
    eval 'sub EXT4_IOC_CHECKPOINT_FLAG_DISCARD () {0x1;}' unless defined(&EXT4_IOC_CHECKPOINT_FLAG_DISCARD);
    eval 'sub EXT4_IOC_CHECKPOINT_FLAG_ZEROOUT () {0x2;}' unless defined(&EXT4_IOC_CHECKPOINT_FLAG_ZEROOUT);
    eval 'sub EXT4_IOC_CHECKPOINT_FLAG_DRY_RUN () {0x4;}' unless defined(&EXT4_IOC_CHECKPOINT_FLAG_DRY_RUN);
    eval 'sub EXT4_IOC_CHECKPOINT_FLAG_VALID () {( &EXT4_IOC_CHECKPOINT_FLAG_DISCARD |  &EXT4_IOC_CHECKPOINT_FLAG_ZEROOUT |  &EXT4_IOC_CHECKPOINT_FLAG_DRY_RUN);}' unless defined(&EXT4_IOC_CHECKPOINT_FLAG_VALID);
    eval 'sub EXT4_GOING_FLAGS_DEFAULT () {0x;}' unless defined(&EXT4_GOING_FLAGS_DEFAULT);
    eval 'sub EXT4_GOING_FLAGS_LOGFLUSH () {0x1;}' unless defined(&EXT4_GOING_FLAGS_LOGFLUSH);
    eval 'sub EXT4_GOING_FLAGS_NOLOGFLUSH () {0x2;}' unless defined(&EXT4_GOING_FLAGS_NOLOGFLUSH);
    eval 'sub EXT4_FIEMAP_EXTENT_HOLE () {0x8000000;}' unless defined(&EXT4_FIEMAP_EXTENT_HOLE);
}
1;
